###################################################
### chunk number 1: Initialize
###################################################
#line 128 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"

## Load common packages, functions and set settings:
library(ordinal)
library(xtable)
## 
RUN <- FALSE    #redo computations and write .RData files
## Change options:
op <- options() ## To be able to reset settings
options("digits" = 7)
options(help_type = "html")
## options("width" = 75)
options("SweaveHooks" = list(fig=function()
        par(mar=c(4,4,.5,0)+.5)))
options(continue=" ")



###################################################
### chunk number 2: 
###################################################
#line 151 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
data(wine)
head(wine)
str(wine)


###################################################
### chunk number 3: 
###################################################
#line 175 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
data(wine)
temp.contact.bottle <- with(wine, temp:contact:bottle)[drop=TRUE]
tab <- xtabs(as.numeric(rating) ~ temp.contact.bottle + judge,
             data=wine) 
class(tab) <- "matrix"
attr(tab, "call") <- NULL
mat <- cbind(rep(c("cold", "warm"), each = 4),
             rep(rep(c("no", "yes"), each=2), 2),
             1:8, tab)
colnames(mat) <-
  c("Temperature", "Contact", "Bottle", 1:9)
xtab <- xtable(mat)
print(xtab, only.contents=TRUE, include.rownames=FALSE,
      sanitize.text.function = function(x) x)


###################################################
### chunk number 4: 
###################################################
#line 216 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
fm1 <- clmm(rating ~ temp + contact, random=judge, data=wine)
fm1


###################################################
### chunk number 5: 
###################################################
#line 225 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
fm2 <- clmm(rating ~ temp + contact, random=judge, data=wine,
            Hess=TRUE, nAGQ=10)
summary(fm2)


###################################################
### chunk number 6: 
###################################################
#line 264 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
exp(coef(fm2)[5])


###################################################
### chunk number 7: 
###################################################
#line 273 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
fm3 <- clmm(rating ~ temp, random=judge, data=wine, nAGQ=10)
anova(fm3, fm2)


###################################################
### chunk number 8: 
###################################################
#line 281 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
fm4 <- clm(rating ~ temp + contact, data=wine)
anova(fm4, fm2)


###################################################
### chunk number 9: 
###################################################
#line 294 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
pr2 <- profile(fm2, range=c(.1, 4), nSteps=30, trace=0)
confint(pr2)


###################################################
### chunk number 10: profilePlot
###################################################
#line 299 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
plot(pr2)


###################################################
### chunk number 11: profileFig
###################################################
#line 309 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
#line 299 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw#from line#309#"
plot(pr2)
#line 310 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"


###################################################
### chunk number 12: ranefPlot
###################################################
#line 326 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
ci <- fm2$ranef + qnorm(0.975) * sqrt(fm2$condVar) %o% c(-1, 1)
ord.re <- order(fm2$ranef)
ci <- ci[order(fm2$ranef),]
plot(1:9, fm2$ranef[ord.re], axes=FALSE, ylim=range(ci),
     xlab="Judge", ylab="Judge effect")
axis(1, at=1:9, labels = ord.re)
axis(2)
for(i in 1:9) segments(i, ci[i,1], i, ci[i, 2])
abline(h = 0, lty=2)


###################################################
### chunk number 13: 
###################################################
#line 347 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
#line 326 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw#from line#347#"
ci <- fm2$ranef + qnorm(0.975) * sqrt(fm2$condVar) %o% c(-1, 1)
ord.re <- order(fm2$ranef)
ci <- ci[order(fm2$ranef),]
plot(1:9, fm2$ranef[ord.re], axes=FALSE, ylim=range(ci),
     xlab="Judge", ylab="Judge effect")
axis(1, at=1:9, labels = ord.re)
axis(2)
for(i in 1:9) segments(i, ci[i,1], i, ci[i, 2])
abline(h = 0, lty=2)
#line 348 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"


###################################################
### chunk number 14: 
###################################################
#line 360 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
head(cbind(wine, fitted(fm2)))


###################################################
### chunk number 15: 
###################################################
#line 366 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
head(cbind(wine, pred=predict(fm2, newdata=wine)))


###################################################
### chunk number 16: 
###################################################
#line 385 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
plogis(fm2$Theta[3] - fm2$beta[2]) - 
  plogis(fm2$Theta[2] - fm2$beta[2])


###################################################
### chunk number 17: 
###################################################
#line 395 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
qnorm(0.95) * c(-1, 1) * fm2$stDev


###################################################
### chunk number 18: 
###################################################
#line 401 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
pred <-
  function(eta, theta, cat = 1:(length(theta)+1), inv.link = plogis)
{
  Theta <- c(-1e3, theta, 1e3)
  sapply(cat, function(j)
         inv.link(Theta[j+1] - eta) - inv.link(Theta[j] - eta) )
}
pred(qnorm(0.05) * fm2$stDev, fm2$Theta)


###################################################
### chunk number 19: 
###################################################
#line 415 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
mat <- expand.grid(judge = qnorm(0.95) * c(-1, 0, 1) * fm2$stDev,
                   contact = c(0, fm2$beta[2]),
                   temp = c(0, fm2$beta[1]))
pred.mat <- pred(eta=rowSums(mat), theta=fm2$Theta)
lab <- paste("contact=", rep(levels(wine$contact), 2), ", ",
             "temp=", rep(levels(wine$temp), each=2), sep="")
par(mfrow=c(2, 2))
for(k in c(1, 4, 7, 10)) {
  plot(1:5, pred.mat[k,], lty=2, type = "l", ylim=c(0,1),
       xlab="Bitterness rating scale", axes=FALSE,
       ylab="Probability", main=lab[ceiling(k/3)], las=1)
  axis(1); axis(2)
  lines(1:5, pred.mat[k+1, ], lty=1)
  lines(1:5, pred.mat[k+2, ], lty=3)
  legend("topright",
         c("avg. judge", "5th %-tile judge", "95th %-tile judge"),
         lty=1:3, bty="n")
}


###################################################
### chunk number 20: 
###################################################
#line 438 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
k <- 1
plot(1:5, pred.mat[k,], lty=2, type = "l", ylim=c(0,1),
     xlab="Bitterness rating scale", axes=FALSE,
     ylab="Probability", main=lab[ceiling(k/3)], las=1)
axis(1); axis(2)
lines(1:5, pred.mat[k+1, ], lty=1)
lines(1:5, pred.mat[k+2, ], lty=3)
legend("topright",
       c("avg. judge", "5th %-tile judge", "95th %-tile judge"),
       lty=1:3, bty="n")


###################################################
### chunk number 21: 
###################################################
#line 450 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
k <- 4
plot(1:5, pred.mat[k,], lty=2, type = "l", ylim=c(0,1),
     xlab="Bitterness rating scale", axes=FALSE,
     ylab="Probability", main=lab[ceiling(k/3)], las=1)
axis(1); axis(2)
lines(1:5, pred.mat[k+1, ], lty=1)
lines(1:5, pred.mat[k+2, ], lty=3)
legend("topright",
       c("avg. judge", "5th %-tile judge", "95th %-tile judge"),
       lty=1:3, bty="n")


###################################################
### chunk number 22: 
###################################################
#line 462 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
k <- 7
plot(1:5, pred.mat[k,], lty=2, type = "l", ylim=c(0,1),
     xlab="Bitterness rating scale", axes=FALSE,
     ylab="Probability", main=lab[ceiling(k/3)], las=1)
axis(1); axis(2)
lines(1:5, pred.mat[k+1, ], lty=1)
lines(1:5, pred.mat[k+2, ], lty=3)
legend("topright",
       c("avg. judge", "5th %-tile judge", "95th %-tile judge"),
       lty=1:3, bty="n")


###################################################
### chunk number 23: 
###################################################
#line 474 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
k <- 10
plot(1:5, pred.mat[k,], lty=2, type = "l", ylim=c(0,1),
     xlab="Bitterness rating scale", axes=FALSE,
     ylab="Probability", main=lab[ceiling(k/3)], las=1)
axis(1); axis(2)
lines(1:5, pred.mat[k+1, ], lty=1)
lines(1:5, pred.mat[k+2, ], lty=3)
legend("topright",
       c("avg. judge", "5th %-tile judge", "95th %-tile judge"),
       lty=1:3, bty="n")


###################################################
### chunk number 24: 
###################################################
#line 494 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
exp(2*qnorm(0.95) * fm2$stDev)


###################################################
### chunk number 25: 
###################################################
#line 501 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"
exp(2*qnorm(0.75) * fm2$stDev)


###################################################
### chunk number 26: misc eval=FALSE
###################################################
## #line 513 "d:/Rcompile/CRANpkg/local/2.12/ordinal/inst/doc/clmm_tutorial.Rnw"


